lightOJ 1205(Palindromic Numbers数位DP)

Palindromic Numbers

Time Limit: 2000MS Memory Limit: 32768KB 64bit IO Format: %lld & %llu

Submit Status

Description

A palindromic number or numeral palindrome is a ‘symmetrical’ number like 16461 that remains the same when its digits are reversed. In this problem you will be given two integers i j, you have to find the number of palindromic numbers between i and j (inclusive).

Input

Input starts with an integer T (≤ 200), denoting the number of test cases.

Each case starts with a line containing two integers i j (0 ≤ i, j ≤ 1017).

Output

For each case, print the case number and the total number of palindromic numbers between i and j (inclusive).

Sample Input

4

1 10

100 1

1 1000

1 10000

Sample Output

Case 1: 9

Case 2: 18

Case 3: 108

Case 4: 198

Source

Problem Setter: Jane Alam Jan

题意比较简单,我就直接上代码了,一些步骤我有记在代码里;

/* ***********************************************
Author        :xdlove
Created Time  :2015年08月18日 星期二 13时18分54秒
File Name     :xd.cpp
 ************************************************ */

/*
 * lightOJ 1205 (数位DP)
 * dp[i][j] 表示以j开头的i位数
 * 处理比较烦。。。
 */

#include <stdio.h>
#include <string.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <stdlib.h>
#include <time.h>
using namespace std;

/********************************

     please don‘t hack me!! /(ToT)/~~

                __------__
              /~          ~             |    //^\\//^\|
           /~~\  ||  T| |T|:~          | |6   ||___|_|_||:|
           \__.  /      o  \/‘
            |   (       O   )
   /~~~~\    `\  \         /
  | |~~\ |     )  ~------~` /‘ |  | |   /     ____ /~~~)(_/‘   | | |     /‘    |    ( |
       | | |     \    /   __)/        \  \ \      \/    /‘ \   `         \  \|\        /   | |\___|
           \ |  \____/     | |
           /^~>  \        _/ <
          |  |         \                 |  | \        \                  -^-\  \       |        )
               `\_______/^\______/

************************************/

#define clr(a) memset(a,0,sizeof(a));
typedef long long ll;
ll dp[20][10];
ll haha;
int tol;
int bit[20],nm[20];

bool check(ll x)
{
    ll n = x;
    ll res = 0;
    while(n)
    {
        res = res * 10 + n % 10;
        n /= 10;
    }
    return x == res;
}

ll fuck(ll l,ll r,int t)
{
    //除了第一位不能取0外,其他位可以取0,用t来进行标记
    ll ans = 0;
    if(l == r)
    {
        ll tp = 0;
        nm[l] = nm[r] = bit[r];
        for(int i = tol; i >= 1; i--)
            tp = tp * 10 + nm[i];
        if(tp <= haha) //因为我是一位一位的确定,所以最后需要与原先的数进行比较,因为这个坑了我好久
            return bit[l] + 1;
        return bit[l];
    }
    if(l > r)
    {
        ll tp = 0;
        for(int i = tol; i >= 1; i--)
            tp = tp * 10 + nm[i];
        if(tp <= haha) return 1;
        return 0;
    }
    for(int i = bit[r] - 1; i >= t; i--)
        ans += dp[r - l + 1][i];
    nm[l] = nm[r] = bit[r];
    return ans + fuck(l + 1,r - 1,0);
}

ll solve(ll n)
{
    ll ans = 1; //0也是回文数
    haha = n;
    if(n < 0) return 0;
    if(n < 10) return n + 1;
    tol = 0;
    while(n) //将n进行拆位
    {
        bit[++tol] = n % 10;
        n /= 10;
    }
    for(int i = tol - 1; i >= 1; i--) // 预先算出每一个位为0的时候所有的回文数
        for(int j = 1; j < 10; j++)
            ans += dp[i][j];
    ans += fuck(1,tol,1); //递归处理,一次确定每一个位的数
    return ans;
}

int main()
{
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    for(int i = 0; i < 10; i++)
        dp[1][i] = dp[2][i] = 1;
    for(int i = 3; i <= 18; i++)
        for(int j = 0; j < 10; j++)
            for(int k = 0; k < 10; k++)
                dp[i][j] += dp[i - 2][k];
    int T,cnt = 0;
    ll l,r;
    cin>>T;
    while(T--)
    {
        cin>>l>>r;
        if(l > r) swap(l,r);
        printf("Case %d: ",++cnt);
        cout<<solve(r) - solve(l - 1)<<endl;
    }
    return 0;
}

版权声明:追逐心中的梦想,永不放弃! By-xdlove

时间: 2024-11-07 15:11:30

lightOJ 1205(Palindromic Numbers数位DP)的相关文章

LightOJ 1205 - Palindromic Numbers (数位dp)

LightOJ 1205 - Palindromic Numbers (数位dp) ACM 题目地址:SPOJ MYQ10 Mirror Number 题意: 求[a,b]中回文的个数. 分析: 是SPOJ MYQ01的简单版...其实有非递归方法的. 代码: /* * Author: illuz <iilluzen[at]gmail.com> * Blog: http://blog.csdn.net/hcbbt * File: 1205.cpp * Create Date: 2014-08-

LightOJ 1205 Palindromic Numbers

数位DP.... Palindromic Numbers Time Limit: 2000MS Memory Limit: 32768KB 64bit IO Format: %lld & %llu [Submit]   [Go Back]   [Status] Description A palindromic number or numeral palindrome is a 'symmetrical' number like 16461 that remains the same when

[数位dp] lightoj 1205 Palindromic Numbers

题意:给定范围内是回文数的个数. 思路: dp[site][len]  site位的回文长度是len. 需要一个负责数组 ok存每位放的数. 然后就是dfs了,就是取len 的中间值mid 超过mid的话 就看看ok里面之前对称的那个数 判断是否相等 相等才能放进入下一位. 注意判断前导0,和这个oj必须用long long. 代码: #include"cstdlib" #include"cstdio" #include"cstring" #in

cf55dBeautiful numbers数位dp

想到 最小公倍数 其余的就好搞了 ,可是没想到 #include <cstdio> #include <cstring> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <cstdlib> #include <list> #include <

Balanced Numbers数位dp

三进制搞下, 0  表示没出现过,  第i位为1 表示 i出现了奇数次,  2表示i 出现了偶数次. #include <cstdio> #include <cstring> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <cstdlib> #includ

[Codefoces 401D]Roman and Numbers 数位dp

http://codeforces.com/problemset/problem/401/D 题目大意:给定一个数字n,将n的每一位数字重新排列,求在这些排列数之中可以被n整除的方法数. 解题思路: 暴力超时-- 大多数人的写法是进行位压缩,不过那样的话需要2^18*100 的空间,效率比较低,重复状态数较多,处理起来也不方便,这一题是给出了512M的空间.但是如果空间再小一倍,前者的方法就无能为力了. 发现有一种对于数位dp来说比较好的状态压缩方式,直接根据数码x出现的次数进行状态压缩.比如说

uva 10712 - Count the Numbers(数位dp)

题目链接:uva 10712 - Count the Numbers 题目大意:给出n,a,b:问说在a到b之间有多少个n. 解题思路:数位dp,dp[i][j][x][y]表示第i位为j的时候,x是否前面是相等的,y是否已经出现过n.对于n=0的情况要特殊处理前导0,写的非常乱,搓死. #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> using na

poj 3340 Barbara Bennett&#39;s Wild Numbers(数位DP)

Barbara Bennett's Wild Numbers Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 3153   Accepted: 1143 Description A wild number is a string containing digits and question marks (like 36?1?8). A number X matches a wild number W if they hav

CodeForces 55D Beautiful numbers 数位DP+数学

题意大概是,判断一个正整数区间内有多少个整数能被它自身的每一个非零的数字整除. 因为每一个位置上的整数集s = {0,1,2,3,4,5,6,7,8,9} lcm(s) = 2520 现在有一个整数t是由s中一个或者多个数字构成的,记为abcde,显然t = a*10^4+b*10^3+c*10^2+d*10^1+e 要使得t能被a,b,c,d,e整除,必然有t % lcm(a,b,c,d,e) = 0 因为a,b,c,d,e去重之后一定是s的一个子集,所以lcm(s)一定是lcm(a,b,c,